{***(V.K.)**********************************************************************
	IEHelper - sceleton BHO (IE's event sinking and manipulation)
  implementation in OP.

  Developed by Vadim Krochak (based on IEHelper VC++ MSDN sample).
*******************************************************************************}

unit Events_Form_U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SHDocVw_TLB;

type

  TEvents_Form = class(TForm)
    Memo: TMemo;
    URL_Edit: TEdit;
    Label1: TLabel;
    Go_Btn: TButton;
    GoBack_Btn: TButton;
    GoForward_Btn: TButton;
    ClearLog_Btn: TButton;
    procedure Go_BtnClick(Sender: TObject);
    procedure GoBack_BtnClick(Sender: TObject);
    procedure GoForward_BtnClick(Sender: TObject);
    procedure ClearLog_BtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure URL_EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

	private
  	FWebBrowser: IWebBrowser2;

  public
  	procedure LogEvent(const Msg: String);
    property WebBrowser: IWebBrowser2 write FWebBrowser;

  end;

//var
//  Events_Form: TEvents_Form;

//******************************************************************************
//******************************************************************************

implementation

{$R *.DFM}

uses DOMAccess;

//******************************************************************************
//******************************************************************************

procedure TEvents_Form.FormShow(Sender: TObject);
begin

	Self.Left := 0;
  Self.Top := 0;
  
end;

//******************************************************************************
procedure TEvents_Form.LogEvent(const Msg: String);
begin

	Self.Memo.Lines.Add(Msg);
  
end;

//******************************************************************************
procedure TEvents_Form.Go_BtnClick(Sender: TObject);
var
	URL: WideString;
begin

	if Assigned(Self.FWebBrowser) then
  begin
  	URL := Self.URL_Edit.Text;
    try
			Self.FWebBrowser.Navigate(URL, EmptyParam, EmptyParam, EmptyParam, EmptyParam);
    except
      on E: Exception do
      begin
				ShowMessage('Exception raised: ' + E.Message);
      end;
    end;//try-except
  end;// if

end;

//******************************************************************************
procedure TEvents_Form.GoBack_BtnClick(Sender: TObject);
begin

	if Assigned(Self.FWebBrowser) then
  begin
  	try
    	{**(V.K.)****************************************
      	If there is nowhere to go - empty history or
        start of history nothing must happend, IE MUST
        ignore navigation request (also by documentation).

        Works great on VC++, but in Delphi exception
        will be raised!

        One more proof that M$ has one COM/OLE specification
        in Redmond and another - 4 rest of
        developers/tools vendors.
        Or, maybe Borland gone wrong?
      ************************************************}
			Self.FWebBrowser.GoBack();
    except
      on E: Exception do
      begin
				ShowMessage('Exception raised: ' + E.Message);
      end;
    end;//try-except
  end;// if

end;

//******************************************************************************
procedure TEvents_Form.GoForward_BtnClick(Sender: TObject);
begin

	if Assigned(Self.FWebBrowser) then
  begin
  	try
			Self.FWebBrowser.GoForward();
    except
      on E: Exception do
      begin
				ShowMessage('Exception raised: ' + E.Message);
      end;
    end;//try-except
  end;// if

end;

//******************************************************************************
procedure TEvents_Form.ClearLog_BtnClick(Sender: TObject);
begin
	Self.Memo.Clear();
end;

//******************************************************************************
procedure TEvents_Form.URL_EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin

	if Key = VK_RETURN then
		Self.Go_BtnClick(Self.Go_Btn);
    
end;

end.////////////////////////////////////////////////////////////////////////////
